<!DOCTYPE html>
<html lang="de">
	<head>
		<meta charset="utf-8" />
		<title>WED1 - JavaScript: Einführung</title>
		<link rel="icon" href="../HSR.Template.Exercises/icon-document.png" type="image/png">

		<link rel="stylesheet" type="text/css" href="../HSR.Template.Exercises/documentStyle.css">
		<script src="../HSR.Template.Exercises/solutions.js"></script>
		<script src="https://cdn.rawgit.com/google/code-prettify/master/loader/run_prettify.js"></script>
		<style>
			.solutionBox { width: 100%; height: 5em; }
			.marked { background: lightgreen; }
		</style>
	</head>
	<body>
		<h1>
			<a class="backlink" href="../index.html">⇦</a>
			WED1 - JavaScript Einführung
			<button id="showSolutions">Lösungen anzeigen/ausblenden</button>
		</h1>


		<h2>Installation</h2>
		<p>Installieren Sie <a href="https://nodejs.org/en/" target="_blank">Node.js</a></p>

		<h2>Node.js Console</h2>
		<p>Starten Sie Node.Js über die Console.</p>
		<p>Machen Sie sich mit der Console vertraut:</p>
		<ul>
			<li>Überprüfen Sie ob die Ausgaben von der Folie <code>The Abstract Equality Comparison Algorithm</code> stimmen.</li>
			<li>Gehen Sie durch die Codebeispiele von <strong>Numbers und '+ - * /'</strong>. Versuchen Sie die jeweiligen Outputs mit eigenen Worten zu begründen.</li>
			<li>Definieren Sie eine Funktion <code>add(a, b){ ... }</code> und rufen Sie diese auf.</li>
		</ul>


		<h2>Node.js File</h2>
		<p>Erstellen Sie ein JavaScript File mit der <code>add(a, b){ ... }</code> Funktion inkl. Testaufruf ( console.log(add(... ) ).</p>
		<ul>
			<li>Führen Sie dieses File mit <code>node [filename]</code> aus.</li>
			<li>Führen Sie dieses File mit WebStorm aus.</li>
		</ul>


		<h2>JavaScript Expression</h2>
		<p>Geben Sie für die folgenden JavaScript Expression jeweils an was das in der Konsole angezeigt wird. Nehmen Sie an, dass die Expressions in der gleichen Umgebung nacheinander ausgeführt werden.</p>
		<ol>
			<li><pre class="prettyprint"><code class="language-javascript">console.log({a:[3,2,1], b:3}['b']);</code></pre></li>
			<li><pre class="prettyprint"><code class="language-javascript">console.log({a:[3,2,1], b:3}.a);</code></pre></li>
			<li><pre class="prettyprint"><code class="language-javascript">console.log(typeof({a:[3,2,1], b:3}.a[9/3]));</code></pre></li>
			<li><pre class="prettyprint"><code class="language-javascript">a=[0.1,0.2,0.3]; console.log(typeof(a));</code></pre></li>
			<li><pre class="prettyprint"><code class="language-javascript">console.log(a[0]+a[1]-a[2]==0);</code></pre></li>
		</ol>
		<div class="solution">
			<p>Nutzen Sie die Console!</p>
		</div>


		<h2>JavaScript Fallgruben</h2>
		<p>Im <a href="files/fallgrube.js">Fallgrube.js</a> haben sich einige Fehler eingeschlichen.</p>
		<p>Korrigieren Sie die Funktionen damit der Output stimmt.</p>
		<p>Nutzen Sie diese Aufgabe um den Debugger von Webstorm auszuprobieren.</p>

		<div class="solution">
			<pre class="prettyprint"><code class="language-javascript"><!--
-->function sumAllPrices() {
	var allPrices = 0;
	for (var i = 0; i < sampleData.length; ++i) {
		allPrices += sampleData[i].price;
	}
	return allPrices;
}

function sortByQuantity() {
	var quantities =  [ ];
	for (var i = 0; i < sampleData.length; ++i) {
		quantities[quantities.length] = sampleData[i].quantity;
	}
	quantities.sort(function(a, b){ return (a > b); });
	return quantities;
}

function getUnavailableBookTitles() {
	var titles = [ ];
	for (var i = 0; i < sampleData.length; ++i) {
		if (sampleData[i].quantity === 0) {
			titles[titles.length] = sampleData[i].title;
		}
	}
	return titles;
}

function getReleaseYears() {
	var years = [ ];
	for (var i = 0; i < sampleData.length; ++i) {
		years[i] = parseInt(sampleData[i].release, 10);
	}
	return years;
}

function getOnlyProvidedData() {
	var data = [ ];
	for (var i = 0; i < sampleData.length; ++i) {
		if (sampleData[i].data !== undefined) {
			data[data.length] = sampleData[i].data;
		}
	}
	return data;
}<!--
		--></code></pre>
		</div>


		<h2>JavaScript Typen</h2>
		<p>Schauen sie sich das folgende Programm an. Geben sie an, was die console.log-Statements jeweils ausgeben und weshalb.
			Lösen Sie zuerst die Aufgabe auf dem Papier, bevor sie das Programm von Node.js ausführen lassen.</p>
		<pre class="prettyprint"><code class="language-javascript"><!--
-->function main() {
    console.log(a, typeof a); // value:         type:               reason:
    var a = 5.5;
    console.log(a, typeof a); // value:         type:               reason:

    var b = parseInt(a);
    console.log(b, typeof b); // value:         type:               reason:

    var c = b + "5";
    console.log(c, typeof c); // value:         type:               reason:

    var d = "5" + b;
    console.log(d, typeof d); // value:         type:               reason:

    var e = b + b + "auto";
    console.log(e, typeof e); // value:         type:               reason:

    var f = b - "3";
    console.log(f, typeof f); // value:         type:               reason:

    var g = b - "a";
    console.log(g, typeof g); // value:         type:               reason:

    var h = "abc" < "def";
    console.log(h, typeof h); // value:         type:               reason:

    var i = [];
    console.log(i, typeof i); // value:         type:               reason:

    var j = {};
    console.log(j, typeof j); // value:         type:               reason:

    console.log(i == "");    // value:                              reason:

    console.log(j == "");    // value:                              reason:

    console.log(i === "");     // value:                            reason:

    var k = function() { return "a"; }
    console.log(k, typeof k); // value:         type:               reason:

    var l = main;
    console.log(l, typeof l); // value:         type:               reason:

    var m = NaN;
    console.log(m, typeof m); // value:         type:               reason:

    var n = null;
    console.log(n, typeof n); // value:         type:               reason:

    var o = /hsr/i;
    console.log(o, typeof o); // value:         type:               reason:

    console.log(typeof undefined);     // value:                    reason:

    console.log(null === undefined);   // value:                    reason:

    console.log(null == undefined);    // value:                    reason:
}
main();<!--
			--></code></pre>
		<div class="solution">
			<pre class="prettyprint"><code class="language-javascript"><!--
-->undefined 'undefined'


a) 5.5 'number'

b) 5 'number'
JavaScript kennt nur Float (number), kein Integer

c) 55 string
Ist einer der beiden Operanden ein String, so werden die Andern in einen String gecastet

d) 55 string
Siehe oben

e) 10auto string
- Expressions werden von links nach rechts aufgelöst.
- Jede Berechnung (Operand, Operator, Operand) wird einzeln durchgeführt.
- Falls notwendig werden Operanden gecastet.
Die ersten beiden Operanden sind Zahlen und deshalb addierbar.
Das Resultat der Addition wird in einen String gecastet,
damit es mit dem String verrechnet werden kann.

f) 2 'number'
String kennt keinen (-)-Operator. Deshalb wird versucht, den String in eine Zahl zu casten.

g) NaN 'number'
String kennt keinen (-)-Operator. Deshalb wird versucht,
den String in eine Zahl zu casten, was in diesem Fall scheitert.

h) true 'boolean'
Der ASCII-Wert wird verglichen

i) [] 'object'
Auch Arrays sind Objekte

j) {} 'object'
Leeres Objekt

j) true
Bei Vergleichen wird immer nach boolean gecastet.
Leeres Array zu boolean gecastet: false, leerer String ebenfalls.

false
Leeres Objekt zu boolean gecastet: true

false
=== vergleicht auch den Typ, kein Cast

k) [Function] 'function'
Anonyme Funktion, besitzt keinen Namen

l) [Function: main] 'function'
Referenz auf Funktion 'main'

m) NaN 'number'
NaN ist vom Typ 'number', auch wenn der 'Wert' keine eigentliche Zahl ist.

n) null 'object'
Auch null ist ein Object

o) /hsr/i 'object'
Regular Expressions sind auch Objekte

undefined
undefined ist eine unbekannte Variable

false
null und eine unbekannte Variable haben nicht den gleichen Typ

true
Null und eine unbekannte Variable casten beide zu false<!--
			--></code></pre>
		</div>

		<h2>JavaScript üben</h2>
		<p>Folgend sind ein einige Aufgabenstellungen definiert. Versuchen Sie diese zu lösen um ein Gefühl für JavaScript zu erhalten</p>
		<p>Schreiben Sie für folgene Probleme eine Funktion und einige sinnvolle console.log(...)-Tests</p>
		<ul>
			<li><strong>isArray(value)</strong> Soll überprüfen ob ein Parameter ein Array ist.</li>
			<li><strong>isPalindrome(value)</strong> Soll überprüfen ob der Parameter ein Palindrom ist.</li>
			<ul>
				<li>Version 1: mit for-schleife</li>
				<li>Version 2: ohne for-schleife</li>
			</ul>
			<li><strong>showData(obj)</strong> Soll alle <code>key = value</code> eines Objektes ausgeben.</li>
			<li>Stellen Sie sich eigene Aufgaben :-)</li>
		</ul>

		<div class="solution">
			<p>Eine mögliche <a href="solution/showData.js" target="_blank">Lösung</a></p>
		</div>

	</body>
</html>
